#include "ot4xb.ch"
#include "dll.ch"
#include "Appevent.ch"
#include "MyReceiverClassName.ch"
// ---------------------------------------------------------------------------
#define WM_COPYDATA                     0x004A
// ---------------------------------------------------------------------------
// Templates for DLL functions
static _tfpFindWindow_
static _tfpSendMessage_
// ---------------------------------------------------------------------------
proc main()
local GetList := {}
local cText
while Lastkey() != 27   
   CLS
   cText := Space(78)
   ?? "Type some text and press RETURN to transfer."
   ? "Esc to close the window"
   SetCursor(1)
   @ Row() +1 ,0 GET cText    
   ? Chrr(45,78) 
   READ
   SendString(cText) // Send the string with WM_COPYDATA to receiver.exe if running
end
return
// ---------------------------------------------------------------------------
init proc _PrepareDllImportFunctions_()
_tfpSendMessage_     := DllPrepareCall(GetHUser32(),DLL_STDCALL,"SendMessageA")
_tfpFindWindow_      := DllPrepareCall(GetHUser32(),DLL_STDCALL,"FindWindowA")
return
// ---------------------------------------------------------------------------
function SendString( cStr , lRetry)
local cClsName := MY_RECEIVER_WND_CLASSNAME 
local pData    := 0
local pBuffer  := 0
local nLen     := 0
static hWndReceiver := NIL                                               

if hWndReceiver == NIL
   hWndReceiver := DllExecuteCall( _tfpFindWindow_ , @cClsName , 0)
   if( hWndReceiver == 0 ) ; hWndReceiver := NIL ; end
end          

if( (hWndReceiver != NIL ) .and. (!Empty(cStr)) )
   pBuffer := _xgrab( cStr , @nLen )
   pData   := _xgrab( 4 * 3 )
   // This time instead of use a gwst structure class to manipulate the 
   // COPYDATASTRUCT structure we can show how to manipulate simple and
   // small structures directly using Peek...() and Poke...() functions.
   //  typedef struct tagCOPYDATASTRUCT {
   //       ULONG_PTR dwData;  // aData[1] Command ID
   //       DWORD cbData;      // aData[2] Len() of the data
   //       PVOID lpData;      // aData[3] Pointer to the buffer
   //    } COPYDATASTRUCT, *PCOPYDATASTRUCT;
   // PeekDWord( pBuffer , nShift , nDWORDs ) -> aDWords  
   PokeDWord( pData , 0 , 0 , nLen , pBuffer ) 
   if DllExecuteCall( _tfpSendMessage_ , hWndReceiver, WM_COPYDATA , 0, pData ) == 0 
      hWndReceiver := NIL // The receiver window can be closed by the user after the 
                          // first call so we will give another chance to find the new 
                          // receiver window and send the data 
                          // lRetry MUST BE .F. this time to avoid infinite recursivity
      if( lRetry == NIL ) ; lRetry := .T. ; end
      if( lRetry ) ;  SendString( cStr , .F.) ; end
   end
   _xfree( pBuffer )
   _xfree( pData )
end
return NIL
// ---------------------------------------------------------------------------
